﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.ComponentModel;

namespace DateTimePickerValidation
{
	public class ViewModel : ViewModelBase, IDataErrorInfo
	{
		private DateTime? date;

		public DateTime? Date
		{
			get
			{
				return this.date;
			}
			set
			{
				this.date = value;
				OnPropertyChanged(() => this.Date);

			}
		}

		public string Error
		{
			get 
			{
				return this.ValidateDate();
			}
		}

		public string this[string columnName]
		{
			get
			{
				switch (columnName)
				{
					case "Date":
						return this.ValidateDate();
				}
				return null;
			}
		}

		private string ValidateDate()
		{
			if (!this.Date.HasValue)
			{
				return "Enter date";
			}

			if (this.Date.Value >= DateTime.Now.AddDays(20))
			{
				return "Date should not be later than 20 days from today";
			}

			return null;
		}
	}
}
